// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: telemetry/Inverter.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace Inverter {

  /// <summary>Holder for reflection information generated from telemetry/Inverter.proto</summary>
  public static partial class InverterReflection {

    #region Descriptor
    /// <summary>File descriptor for telemetry/Inverter.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static InverterReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "Chh0ZWxlbWV0cnkvSW52ZXJ0ZXIucHJvdG8SCGludmVydGVyGh9nb29nbGUv",
            "cHJvdG9idWYvdGltZXN0YW1wLnByb3RvIr4GCghJbnZlcnRlchIRCgRsb2Fk",
            "GAEgASgJSACIAQESFAoHY3VycmVudBgCIAEoCUgBiAEBEhQKB3ZvbHRhZ2UY",
            "AyABKAlIAogBARIYCgt0ZW1wZXJhdHVyZRgEIAEoCUgDiAEBEhkKDGFjdGl2",
            "ZV9wb3dlchgFIAEoCUgEiAEBEhsKDmFwcGFyZW50X3Bvd2VyGAYgASgJSAWI",
            "AQESGwoOcmVhY3RpdmVfcG93ZXIYByABKAlIBogBARIXCgpsb2FkX3JhdGlv",
            "GAggASgJSAeIAQESHgoRdG90YWxfbG9hZF9lbmVyZ3kYCSABKAlICIgBARIV",
            "CghkY19wb3dlchgKIAEoCUgJiAEBEiIKFWluc3VsYXRpb25fcmVzaXN0YW5j",
            "ZRgLIAEoCUgKiAEBEhkKDHBvd2VyX2ZhY3RvchgMIAEoCUgLiAEBEhcKCnBp",
            "ZF9zdGF0dXMYDSABKAlIDIgBARIiChV0b3RhbF9wcm9kdWNlZF9lbmVyZ3kY",
            "FCABKAlIDYgBARIiChV0b2RheV9wcm9kdWNlZF9lbmVyZ3kYFSABKAlIDogB",
            "ARInChp0aGlzX21vbnRoX3Byb2R1Y2VkX2VuZXJneRgWIAEoCUgPiAEBEiYK",
            "GXRoaXNfeWVhcl9wcm9kdWNlZF9lbmVyZ3kYFyABKAlIEIgBAUIHCgVfbG9h",
            "ZEIKCghfY3VycmVudEIKCghfdm9sdGFnZUIOCgxfdGVtcGVyYXR1cmVCDwoN",
            "X2FjdGl2ZV9wb3dlckIRCg9fYXBwYXJlbnRfcG93ZXJCEQoPX3JlYWN0aXZl",
            "X3Bvd2VyQg0KC19sb2FkX3JhdGlvQhQKEl90b3RhbF9sb2FkX2VuZXJneUIL",
            "CglfZGNfcG93ZXJCGAoWX2luc3VsYXRpb25fcmVzaXN0YW5jZUIPCg1fcG93",
            "ZXJfZmFjdG9yQg0KC19waWRfc3RhdHVzQhgKFl90b3RhbF9wcm9kdWNlZF9l",
            "bmVyZ3lCGAoWX3RvZGF5X3Byb2R1Y2VkX2VuZXJneUIdChtfdGhpc19tb250",
            "aF9wcm9kdWNlZF9lbmVyZ3lCHAoaX3RoaXNfeWVhcl9wcm9kdWNlZF9lbmVy",
            "Z3lCdAobY29tLmNvZGlibHkubW9kZWwudGVsZW1ldHJ5Qg1JbnZlcnRlclBy",
            "b3RvygIbRG9tYWluTW9kZWxcUHJvdG9cVGVsZW1ldHJ54gInRG9tYWluTW9k",
            "ZWxcUHJvdG9cVGVsZW1ldHJ5XEdQQk1ldGFkYXRhYgZwcm90bzM="));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { global::Google.Protobuf.WellKnownTypes.TimestampReflection.Descriptor, },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::Inverter.Inverter), global::Inverter.Inverter.Parser, new[]{ "Load", "Current", "Voltage", "Temperature", "ActivePower", "ApparentPower", "ReactivePower", "LoadRatio", "TotalLoadEnergy", "DcPower", "InsulationResistance", "PowerFactor", "PidStatus", "TotalProducedEnergy", "TodayProducedEnergy", "ThisMonthProducedEnergy", "ThisYearProducedEnergy" }, new[]{ "Load", "Current", "Voltage", "Temperature", "ActivePower", "ApparentPower", "ReactivePower", "LoadRatio", "TotalLoadEnergy", "DcPower", "InsulationResistance", "PowerFactor", "PidStatus", "TotalProducedEnergy", "TodayProducedEnergy", "ThisMonthProducedEnergy", "ThisYearProducedEnergy" }, null, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class Inverter : pb::IMessage<Inverter>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<Inverter> _parser = new pb::MessageParser<Inverter>(() => new Inverter());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<Inverter> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Inverter.InverterReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Inverter() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Inverter(Inverter other) : this() {
      load_ = other.load_;
      current_ = other.current_;
      voltage_ = other.voltage_;
      temperature_ = other.temperature_;
      activePower_ = other.activePower_;
      apparentPower_ = other.apparentPower_;
      reactivePower_ = other.reactivePower_;
      loadRatio_ = other.loadRatio_;
      totalLoadEnergy_ = other.totalLoadEnergy_;
      dcPower_ = other.dcPower_;
      insulationResistance_ = other.insulationResistance_;
      powerFactor_ = other.powerFactor_;
      pidStatus_ = other.pidStatus_;
      totalProducedEnergy_ = other.totalProducedEnergy_;
      todayProducedEnergy_ = other.todayProducedEnergy_;
      thisMonthProducedEnergy_ = other.thisMonthProducedEnergy_;
      thisYearProducedEnergy_ = other.thisYearProducedEnergy_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Inverter Clone() {
      return new Inverter(this);
    }

    /// <summary>Field number for the "load" field.</summary>
    public const int LoadFieldNumber = 1;
    private string load_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Load {
      get { return load_ ?? ""; }
      set {
        load_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "load" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasLoad {
      get { return load_ != null; }
    }
    /// <summary>Clears the value of the "load" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearLoad() {
      load_ = null;
    }

    /// <summary>Field number for the "current" field.</summary>
    public const int CurrentFieldNumber = 2;
    private string current_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Current {
      get { return current_ ?? ""; }
      set {
        current_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "current" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasCurrent {
      get { return current_ != null; }
    }
    /// <summary>Clears the value of the "current" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearCurrent() {
      current_ = null;
    }

    /// <summary>Field number for the "voltage" field.</summary>
    public const int VoltageFieldNumber = 3;
    private string voltage_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Voltage {
      get { return voltage_ ?? ""; }
      set {
        voltage_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "voltage" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasVoltage {
      get { return voltage_ != null; }
    }
    /// <summary>Clears the value of the "voltage" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearVoltage() {
      voltage_ = null;
    }

    /// <summary>Field number for the "temperature" field.</summary>
    public const int TemperatureFieldNumber = 4;
    private string temperature_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Temperature {
      get { return temperature_ ?? ""; }
      set {
        temperature_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "temperature" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTemperature {
      get { return temperature_ != null; }
    }
    /// <summary>Clears the value of the "temperature" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTemperature() {
      temperature_ = null;
    }

    /// <summary>Field number for the "active_power" field.</summary>
    public const int ActivePowerFieldNumber = 5;
    private string activePower_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ActivePower {
      get { return activePower_ ?? ""; }
      set {
        activePower_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "active_power" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasActivePower {
      get { return activePower_ != null; }
    }
    /// <summary>Clears the value of the "active_power" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearActivePower() {
      activePower_ = null;
    }

    /// <summary>Field number for the "apparent_power" field.</summary>
    public const int ApparentPowerFieldNumber = 6;
    private string apparentPower_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ApparentPower {
      get { return apparentPower_ ?? ""; }
      set {
        apparentPower_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "apparent_power" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasApparentPower {
      get { return apparentPower_ != null; }
    }
    /// <summary>Clears the value of the "apparent_power" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearApparentPower() {
      apparentPower_ = null;
    }

    /// <summary>Field number for the "reactive_power" field.</summary>
    public const int ReactivePowerFieldNumber = 7;
    private string reactivePower_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ReactivePower {
      get { return reactivePower_ ?? ""; }
      set {
        reactivePower_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "reactive_power" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasReactivePower {
      get { return reactivePower_ != null; }
    }
    /// <summary>Clears the value of the "reactive_power" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearReactivePower() {
      reactivePower_ = null;
    }

    /// <summary>Field number for the "load_ratio" field.</summary>
    public const int LoadRatioFieldNumber = 8;
    private string loadRatio_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string LoadRatio {
      get { return loadRatio_ ?? ""; }
      set {
        loadRatio_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "load_ratio" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasLoadRatio {
      get { return loadRatio_ != null; }
    }
    /// <summary>Clears the value of the "load_ratio" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearLoadRatio() {
      loadRatio_ = null;
    }

    /// <summary>Field number for the "total_load_energy" field.</summary>
    public const int TotalLoadEnergyFieldNumber = 9;
    private string totalLoadEnergy_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string TotalLoadEnergy {
      get { return totalLoadEnergy_ ?? ""; }
      set {
        totalLoadEnergy_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "total_load_energy" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTotalLoadEnergy {
      get { return totalLoadEnergy_ != null; }
    }
    /// <summary>Clears the value of the "total_load_energy" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTotalLoadEnergy() {
      totalLoadEnergy_ = null;
    }

    /// <summary>Field number for the "dc_power" field.</summary>
    public const int DcPowerFieldNumber = 10;
    private string dcPower_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string DcPower {
      get { return dcPower_ ?? ""; }
      set {
        dcPower_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "dc_power" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasDcPower {
      get { return dcPower_ != null; }
    }
    /// <summary>Clears the value of the "dc_power" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearDcPower() {
      dcPower_ = null;
    }

    /// <summary>Field number for the "insulation_resistance" field.</summary>
    public const int InsulationResistanceFieldNumber = 11;
    private string insulationResistance_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string InsulationResistance {
      get { return insulationResistance_ ?? ""; }
      set {
        insulationResistance_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "insulation_resistance" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasInsulationResistance {
      get { return insulationResistance_ != null; }
    }
    /// <summary>Clears the value of the "insulation_resistance" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearInsulationResistance() {
      insulationResistance_ = null;
    }

    /// <summary>Field number for the "power_factor" field.</summary>
    public const int PowerFactorFieldNumber = 12;
    private string powerFactor_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string PowerFactor {
      get { return powerFactor_ ?? ""; }
      set {
        powerFactor_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "power_factor" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasPowerFactor {
      get { return powerFactor_ != null; }
    }
    /// <summary>Clears the value of the "power_factor" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearPowerFactor() {
      powerFactor_ = null;
    }

    /// <summary>Field number for the "pid_status" field.</summary>
    public const int PidStatusFieldNumber = 13;
    private string pidStatus_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string PidStatus {
      get { return pidStatus_ ?? ""; }
      set {
        pidStatus_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "pid_status" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasPidStatus {
      get { return pidStatus_ != null; }
    }
    /// <summary>Clears the value of the "pid_status" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearPidStatus() {
      pidStatus_ = null;
    }

    /// <summary>Field number for the "total_produced_energy" field.</summary>
    public const int TotalProducedEnergyFieldNumber = 20;
    private string totalProducedEnergy_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string TotalProducedEnergy {
      get { return totalProducedEnergy_ ?? ""; }
      set {
        totalProducedEnergy_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "total_produced_energy" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTotalProducedEnergy {
      get { return totalProducedEnergy_ != null; }
    }
    /// <summary>Clears the value of the "total_produced_energy" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTotalProducedEnergy() {
      totalProducedEnergy_ = null;
    }

    /// <summary>Field number for the "today_produced_energy" field.</summary>
    public const int TodayProducedEnergyFieldNumber = 21;
    private string todayProducedEnergy_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string TodayProducedEnergy {
      get { return todayProducedEnergy_ ?? ""; }
      set {
        todayProducedEnergy_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "today_produced_energy" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTodayProducedEnergy {
      get { return todayProducedEnergy_ != null; }
    }
    /// <summary>Clears the value of the "today_produced_energy" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTodayProducedEnergy() {
      todayProducedEnergy_ = null;
    }

    /// <summary>Field number for the "this_month_produced_energy" field.</summary>
    public const int ThisMonthProducedEnergyFieldNumber = 22;
    private string thisMonthProducedEnergy_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ThisMonthProducedEnergy {
      get { return thisMonthProducedEnergy_ ?? ""; }
      set {
        thisMonthProducedEnergy_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "this_month_produced_energy" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasThisMonthProducedEnergy {
      get { return thisMonthProducedEnergy_ != null; }
    }
    /// <summary>Clears the value of the "this_month_produced_energy" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearThisMonthProducedEnergy() {
      thisMonthProducedEnergy_ = null;
    }

    /// <summary>Field number for the "this_year_produced_energy" field.</summary>
    public const int ThisYearProducedEnergyFieldNumber = 23;
    private string thisYearProducedEnergy_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ThisYearProducedEnergy {
      get { return thisYearProducedEnergy_ ?? ""; }
      set {
        thisYearProducedEnergy_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "this_year_produced_energy" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasThisYearProducedEnergy {
      get { return thisYearProducedEnergy_ != null; }
    }
    /// <summary>Clears the value of the "this_year_produced_energy" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearThisYearProducedEnergy() {
      thisYearProducedEnergy_ = null;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as Inverter);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(Inverter other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (Load != other.Load) return false;
      if (Current != other.Current) return false;
      if (Voltage != other.Voltage) return false;
      if (Temperature != other.Temperature) return false;
      if (ActivePower != other.ActivePower) return false;
      if (ApparentPower != other.ApparentPower) return false;
      if (ReactivePower != other.ReactivePower) return false;
      if (LoadRatio != other.LoadRatio) return false;
      if (TotalLoadEnergy != other.TotalLoadEnergy) return false;
      if (DcPower != other.DcPower) return false;
      if (InsulationResistance != other.InsulationResistance) return false;
      if (PowerFactor != other.PowerFactor) return false;
      if (PidStatus != other.PidStatus) return false;
      if (TotalProducedEnergy != other.TotalProducedEnergy) return false;
      if (TodayProducedEnergy != other.TodayProducedEnergy) return false;
      if (ThisMonthProducedEnergy != other.ThisMonthProducedEnergy) return false;
      if (ThisYearProducedEnergy != other.ThisYearProducedEnergy) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (HasLoad) hash ^= Load.GetHashCode();
      if (HasCurrent) hash ^= Current.GetHashCode();
      if (HasVoltage) hash ^= Voltage.GetHashCode();
      if (HasTemperature) hash ^= Temperature.GetHashCode();
      if (HasActivePower) hash ^= ActivePower.GetHashCode();
      if (HasApparentPower) hash ^= ApparentPower.GetHashCode();
      if (HasReactivePower) hash ^= ReactivePower.GetHashCode();
      if (HasLoadRatio) hash ^= LoadRatio.GetHashCode();
      if (HasTotalLoadEnergy) hash ^= TotalLoadEnergy.GetHashCode();
      if (HasDcPower) hash ^= DcPower.GetHashCode();
      if (HasInsulationResistance) hash ^= InsulationResistance.GetHashCode();
      if (HasPowerFactor) hash ^= PowerFactor.GetHashCode();
      if (HasPidStatus) hash ^= PidStatus.GetHashCode();
      if (HasTotalProducedEnergy) hash ^= TotalProducedEnergy.GetHashCode();
      if (HasTodayProducedEnergy) hash ^= TodayProducedEnergy.GetHashCode();
      if (HasThisMonthProducedEnergy) hash ^= ThisMonthProducedEnergy.GetHashCode();
      if (HasThisYearProducedEnergy) hash ^= ThisYearProducedEnergy.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (HasLoad) {
        output.WriteRawTag(10);
        output.WriteString(Load);
      }
      if (HasCurrent) {
        output.WriteRawTag(18);
        output.WriteString(Current);
      }
      if (HasVoltage) {
        output.WriteRawTag(26);
        output.WriteString(Voltage);
      }
      if (HasTemperature) {
        output.WriteRawTag(34);
        output.WriteString(Temperature);
      }
      if (HasActivePower) {
        output.WriteRawTag(42);
        output.WriteString(ActivePower);
      }
      if (HasApparentPower) {
        output.WriteRawTag(50);
        output.WriteString(ApparentPower);
      }
      if (HasReactivePower) {
        output.WriteRawTag(58);
        output.WriteString(ReactivePower);
      }
      if (HasLoadRatio) {
        output.WriteRawTag(66);
        output.WriteString(LoadRatio);
      }
      if (HasTotalLoadEnergy) {
        output.WriteRawTag(74);
        output.WriteString(TotalLoadEnergy);
      }
      if (HasDcPower) {
        output.WriteRawTag(82);
        output.WriteString(DcPower);
      }
      if (HasInsulationResistance) {
        output.WriteRawTag(90);
        output.WriteString(InsulationResistance);
      }
      if (HasPowerFactor) {
        output.WriteRawTag(98);
        output.WriteString(PowerFactor);
      }
      if (HasPidStatus) {
        output.WriteRawTag(106);
        output.WriteString(PidStatus);
      }
      if (HasTotalProducedEnergy) {
        output.WriteRawTag(162, 1);
        output.WriteString(TotalProducedEnergy);
      }
      if (HasTodayProducedEnergy) {
        output.WriteRawTag(170, 1);
        output.WriteString(TodayProducedEnergy);
      }
      if (HasThisMonthProducedEnergy) {
        output.WriteRawTag(178, 1);
        output.WriteString(ThisMonthProducedEnergy);
      }
      if (HasThisYearProducedEnergy) {
        output.WriteRawTag(186, 1);
        output.WriteString(ThisYearProducedEnergy);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (HasLoad) {
        output.WriteRawTag(10);
        output.WriteString(Load);
      }
      if (HasCurrent) {
        output.WriteRawTag(18);
        output.WriteString(Current);
      }
      if (HasVoltage) {
        output.WriteRawTag(26);
        output.WriteString(Voltage);
      }
      if (HasTemperature) {
        output.WriteRawTag(34);
        output.WriteString(Temperature);
      }
      if (HasActivePower) {
        output.WriteRawTag(42);
        output.WriteString(ActivePower);
      }
      if (HasApparentPower) {
        output.WriteRawTag(50);
        output.WriteString(ApparentPower);
      }
      if (HasReactivePower) {
        output.WriteRawTag(58);
        output.WriteString(ReactivePower);
      }
      if (HasLoadRatio) {
        output.WriteRawTag(66);
        output.WriteString(LoadRatio);
      }
      if (HasTotalLoadEnergy) {
        output.WriteRawTag(74);
        output.WriteString(TotalLoadEnergy);
      }
      if (HasDcPower) {
        output.WriteRawTag(82);
        output.WriteString(DcPower);
      }
      if (HasInsulationResistance) {
        output.WriteRawTag(90);
        output.WriteString(InsulationResistance);
      }
      if (HasPowerFactor) {
        output.WriteRawTag(98);
        output.WriteString(PowerFactor);
      }
      if (HasPidStatus) {
        output.WriteRawTag(106);
        output.WriteString(PidStatus);
      }
      if (HasTotalProducedEnergy) {
        output.WriteRawTag(162, 1);
        output.WriteString(TotalProducedEnergy);
      }
      if (HasTodayProducedEnergy) {
        output.WriteRawTag(170, 1);
        output.WriteString(TodayProducedEnergy);
      }
      if (HasThisMonthProducedEnergy) {
        output.WriteRawTag(178, 1);
        output.WriteString(ThisMonthProducedEnergy);
      }
      if (HasThisYearProducedEnergy) {
        output.WriteRawTag(186, 1);
        output.WriteString(ThisYearProducedEnergy);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (HasLoad) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Load);
      }
      if (HasCurrent) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Current);
      }
      if (HasVoltage) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Voltage);
      }
      if (HasTemperature) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Temperature);
      }
      if (HasActivePower) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ActivePower);
      }
      if (HasApparentPower) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ApparentPower);
      }
      if (HasReactivePower) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ReactivePower);
      }
      if (HasLoadRatio) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(LoadRatio);
      }
      if (HasTotalLoadEnergy) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(TotalLoadEnergy);
      }
      if (HasDcPower) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(DcPower);
      }
      if (HasInsulationResistance) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(InsulationResistance);
      }
      if (HasPowerFactor) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(PowerFactor);
      }
      if (HasPidStatus) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(PidStatus);
      }
      if (HasTotalProducedEnergy) {
        size += 2 + pb::CodedOutputStream.ComputeStringSize(TotalProducedEnergy);
      }
      if (HasTodayProducedEnergy) {
        size += 2 + pb::CodedOutputStream.ComputeStringSize(TodayProducedEnergy);
      }
      if (HasThisMonthProducedEnergy) {
        size += 2 + pb::CodedOutputStream.ComputeStringSize(ThisMonthProducedEnergy);
      }
      if (HasThisYearProducedEnergy) {
        size += 2 + pb::CodedOutputStream.ComputeStringSize(ThisYearProducedEnergy);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(Inverter other) {
      if (other == null) {
        return;
      }
      if (other.HasLoad) {
        Load = other.Load;
      }
      if (other.HasCurrent) {
        Current = other.Current;
      }
      if (other.HasVoltage) {
        Voltage = other.Voltage;
      }
      if (other.HasTemperature) {
        Temperature = other.Temperature;
      }
      if (other.HasActivePower) {
        ActivePower = other.ActivePower;
      }
      if (other.HasApparentPower) {
        ApparentPower = other.ApparentPower;
      }
      if (other.HasReactivePower) {
        ReactivePower = other.ReactivePower;
      }
      if (other.HasLoadRatio) {
        LoadRatio = other.LoadRatio;
      }
      if (other.HasTotalLoadEnergy) {
        TotalLoadEnergy = other.TotalLoadEnergy;
      }
      if (other.HasDcPower) {
        DcPower = other.DcPower;
      }
      if (other.HasInsulationResistance) {
        InsulationResistance = other.InsulationResistance;
      }
      if (other.HasPowerFactor) {
        PowerFactor = other.PowerFactor;
      }
      if (other.HasPidStatus) {
        PidStatus = other.PidStatus;
      }
      if (other.HasTotalProducedEnergy) {
        TotalProducedEnergy = other.TotalProducedEnergy;
      }
      if (other.HasTodayProducedEnergy) {
        TodayProducedEnergy = other.TodayProducedEnergy;
      }
      if (other.HasThisMonthProducedEnergy) {
        ThisMonthProducedEnergy = other.ThisMonthProducedEnergy;
      }
      if (other.HasThisYearProducedEnergy) {
        ThisYearProducedEnergy = other.ThisYearProducedEnergy;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            Load = input.ReadString();
            break;
          }
          case 18: {
            Current = input.ReadString();
            break;
          }
          case 26: {
            Voltage = input.ReadString();
            break;
          }
          case 34: {
            Temperature = input.ReadString();
            break;
          }
          case 42: {
            ActivePower = input.ReadString();
            break;
          }
          case 50: {
            ApparentPower = input.ReadString();
            break;
          }
          case 58: {
            ReactivePower = input.ReadString();
            break;
          }
          case 66: {
            LoadRatio = input.ReadString();
            break;
          }
          case 74: {
            TotalLoadEnergy = input.ReadString();
            break;
          }
          case 82: {
            DcPower = input.ReadString();
            break;
          }
          case 90: {
            InsulationResistance = input.ReadString();
            break;
          }
          case 98: {
            PowerFactor = input.ReadString();
            break;
          }
          case 106: {
            PidStatus = input.ReadString();
            break;
          }
          case 162: {
            TotalProducedEnergy = input.ReadString();
            break;
          }
          case 170: {
            TodayProducedEnergy = input.ReadString();
            break;
          }
          case 178: {
            ThisMonthProducedEnergy = input.ReadString();
            break;
          }
          case 186: {
            ThisYearProducedEnergy = input.ReadString();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            Load = input.ReadString();
            break;
          }
          case 18: {
            Current = input.ReadString();
            break;
          }
          case 26: {
            Voltage = input.ReadString();
            break;
          }
          case 34: {
            Temperature = input.ReadString();
            break;
          }
          case 42: {
            ActivePower = input.ReadString();
            break;
          }
          case 50: {
            ApparentPower = input.ReadString();
            break;
          }
          case 58: {
            ReactivePower = input.ReadString();
            break;
          }
          case 66: {
            LoadRatio = input.ReadString();
            break;
          }
          case 74: {
            TotalLoadEnergy = input.ReadString();
            break;
          }
          case 82: {
            DcPower = input.ReadString();
            break;
          }
          case 90: {
            InsulationResistance = input.ReadString();
            break;
          }
          case 98: {
            PowerFactor = input.ReadString();
            break;
          }
          case 106: {
            PidStatus = input.ReadString();
            break;
          }
          case 162: {
            TotalProducedEnergy = input.ReadString();
            break;
          }
          case 170: {
            TodayProducedEnergy = input.ReadString();
            break;
          }
          case 178: {
            ThisMonthProducedEnergy = input.ReadString();
            break;
          }
          case 186: {
            ThisYearProducedEnergy = input.ReadString();
            break;
          }
        }
      }
    }
    #endif

  }

  #endregion

}

#endregion Designer generated code
